package andante;

import java.io.*;
import java.util.*;
import java.net.InetAddress;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;

import andante.device.*;
import andante.stage.*;
import andante.orb.device.*;
import andante.orb.stage.*;


import com.ibm.aglet.*;
import com.ibm.aglet.event.*;
import java.net.*;

public class AndanteTest {
  public static void main(String args[]) {

    ORB Orb = null;

    try {

      AgletsServer.main(args);

      /*for (int i = 0; i <args.length; i++)
      System.out.print(args[i] +" ");
      System.out.println();*/

      Properties props = new Properties();
      props.put("org.omg.CORBA.ORBInitialHost", "localhost");
      props.put("org.omg.CORBA.ORBInitialPort", "1050");
      Orb = org.omg.CORBA.ORB.init(args, props);

//    AudioDeviceX daI = new AudioDeviceX();
      AudioDeviceImpl daI = new AudioDeviceImpl();
      AudioDevice da = null;
      StageImpl stageI = null;
      Stage stage = null;

      NamingContextExt nc = NamingContextExtHelper.narrow
	(Orb.resolve_initial_references("NameService"));

      NamingContext nc2 = null;
      try {
	nc2 = NamingContextHelper.narrow(nc.resolve(nc.to_name("andante")));
      } catch (NotFound nf) {
	System.out.println(nf);
	nc2 = nc.bind_new_context(nc.to_name("andante"));
      }

      String StageName = InetAddress.getLocalHost().getHostName() + ":" +
	AgletsServer.getPortNum();

      StageName = StageName.replace('.', '-');
      System.out.println("Stage name: " + StageName);

      NamingContext LocalNC = null;
      try {
	LocalNC = NamingContextHelper.narrow(nc2.resolve(nc.to_name(StageName)));
      } catch (NotFound nf) {
	System.out.println(nf);
	LocalNC = nc2.bind_new_context(nc.to_name(StageName));
      }


      POA Poa = org.omg.PortableServer.POAHelper.narrow
	( Orb.resolve_initial_references("RootPOA"));
      Poa.the_POAManager().activate();
      org.omg.CORBA.Object obj = Poa.servant_to_reference(daI);
      da = AudioDeviceHelper.narrow(obj);

      stageI = new StageImpl(StageName, da, Poa);

      obj = Poa.servant_to_reference(stageI);
      stage = StageHelper.narrow(obj);

      NameComponent [] NCName = nc.to_name("Metronome");
      LocalNC.rebind(NCName, stage.getMetronome());

      AgletsServer.getContext().setProperty("Stage", stage);
      AgletsServer.getContext().setProperty("Orb", Orb);
      AgletsServer.getContext().setProperty("NamingContext", LocalNC);

    }
    catch (Exception e) {
      e.printStackTrace();
    }

    (new OrbRun(Orb)).start();
    System.out.println("Ok.");
  }


}

  class OrbRun extends Thread {
    ORB Orb;
    public OrbRun(ORB o) { Orb = o; }
    public void run() { Orb.run(); }
  }

