package andante.apps.noiseweaver;

import org.omg.CORBA.ORB;
import org.omg.CosNaming.*;

import andante.orb.*;
import andante.orb.agent.*;
import andante.orb.stage.*;

import java.io.*;
import java.util.*;
import java.net.InetAddress;

import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.border.*;


public  class NoiseWeaver {

  public static void main (String args[]) {

    try {

      Properties props = new Properties();
      props.put("org.omg.CORBA.ORBInitialHost", "localhost");
      props.put("org.omg.CORBA.ORBInitialPort", "1050");
      ORB Orb = ORB.init(args, props);

      NamingContextExt ncR = NamingContextExtHelper.narrow(Orb.resolve_initial_references("NameService"));
      NamingContext nc = NamingContextHelper.narrow(ncR.resolve_str("andante"));


      JFrame jf = new JFrame("NoiseWeaver@" + InetAddress.getLocalHost());
//      JFrame jf = new JFrame("NoiseWeaver@villa.ime.usp.br");
      jf.addWindowListener(new EKill());

//      JTabbedPane jtp = new JTabbedPane();

      //    jtp.addTab("Name Service", new NSPanel(jf, nc, jtp));

      JPanel jsl = new NCListPanel(nc, "Stages:", true, false);

      jf.getContentPane().add(jsl);
      jf.pack();
      //Dimension x = jtp.getPreferredSize();
      //jf.setSize(new Dimension((int)(x.getWidth() * 1.5), (int)x.getHeight()));
      jf.show();

    } catch (Exception ex) {
      ex.printStackTrace();
    }
  }


}

/*****************************************************************************/

class MyBorder {
  public static Border createBorder(int ot, int or, int ob, int ol,
				    String title,
				    int it, int ir, int ib, int il) {
    return BorderFactory.createCompoundBorder(
      BorderFactory.createCompoundBorder(
	BorderFactory.createEmptyBorder(ot,or,ob,ol),
	BorderFactory.createTitledBorder(
	  BorderFactory.createEtchedBorder(),
	  title)),
      BorderFactory.createEmptyBorder(it,ir,ib,il)
      );
  }
}

/*****************************************************************************/

class StageManager extends JPanel {

  Stage S;

  public StageManager(NamingContext nc) {

    try {
      NameComponent[] nameC = new NameComponent[1];
      nameC[0] = new NameComponent("Metronome","");
      org.omg.CORBA.Object obj = nc.resolve(nameC);
      Metronome m = MetronomeHelper.narrow(obj);
      
      setLayout(new BoxLayout(this, BoxLayout.X_AXIS));

      JPanel leftPane = new JPanel();
      leftPane.setLayout(new BoxLayout(leftPane, BoxLayout.Y_AXIS));

      NoiseAgentManager propsPane = new NoiseAgentManager();


      JPanel agentsPane = new NoiseAgentList(nc, propsPane);
      agentsPane.setBorder(MyBorder.createBorder(5,5,5,5,
						 "Agents",
						 5,5,5,5));

      JPanel metroPane = new MetronomePane(m);
      metroPane.setBorder(MyBorder.createBorder(5,5,5,5,
					      "Metronome",
					      5,5,5,5));
      leftPane.add(metroPane);
      leftPane.add(agentsPane);

      JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
				 leftPane, propsPane);
      splitPane.setOneTouchExpandable(true);
      add(splitPane);

    } catch (Exception ex) { ex.printStackTrace(); }
  }
}


class MetronomePane extends JPanel {
  Metronome M;
  MetronomeValueHolder[] Values;
  MetronomeBooleanHolder[] Checks;
  MetronomePane This;
  
  public MetronomePane(Metronome m) {
    This = this;
    M = m;

    Values = new  MetronomeValueHolder[3];
    Checks = new  MetronomeBooleanHolder[1];

    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    setBorder(BorderFactory.createEmptyBorder(10,10,10,10));

    JPanel tsPane = new JPanel();
    JPanel pulsePane = new JPanel();

    MetronomePropSpinner tempoPane = new 
      MetronomePropSpinner("Tempo:",
			   new MetronomeSpinnerSet() {
			     public void reset(JSpinner s) {
			       s.setValue(new Integer(M.getTempo()));
			     }
			     public void update(JSpinner s) {
			       M.setTempo(((Integer)s.getValue()).intValue());
			     }
			   },
			   1, 400);
    add(tempoPane);

    Values[0] = tempoPane;

    tsPane.setLayout(new BoxLayout(tsPane, BoxLayout.Y_AXIS));
    tsPane.setBorder(MyBorder.createBorder(5,0,5,0,
					      "Time Signature",
					      5,5,5,5));
    MetronomePropSpinner amountPane = new 
      MetronomePropSpinner("Amount:",
			   new MetronomeSpinnerSet() {
			     public void reset(JSpinner s) {
			       s.setValue(new Integer(M.getTSAmount()));
			     }
			     public void update(JSpinner s) {
			       M.setTSAmount(((Integer)s.getValue()).intValue());
			     }
			   },
			   1, 20);
    MetronomePropSpinner typePane = new 
      MetronomePropSpinner("Type:",
			   new MetronomeSpinnerSet() {
			     public void reset(JSpinner s) {
			       s.setValue(new Integer(M.getTSType()));
			     }
			     public void update(JSpinner s) {
			       M.setTSType(((Integer)s.getValue()).intValue());
			     }
			   },
			   1, 32);
    tsPane.add(amountPane);
    tsPane.add(typePane);

    Values[1] = amountPane;
    Values[2] = typePane;

    add(tsPane);

    MetronomePropCheck playPulsePane = new 
      MetronomePropCheck("Play pulses",
			   new MetronomeCheckSet() {
			     public void reset(JCheckBox c) {
			       c.setSelected(M.isPlayingPulses());
			     }
			     public void update(JCheckBox c) {
			       M.playPulses(c.isSelected());
			     }
			   });

    Checks[0] = playPulsePane;
    add(playPulsePane);

    JButton bSync = new JButton("Synchronize");    
    bSync.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
          M.synchronize();
	}
      });
    add(bSync);

    JPanel buttonPane = new JPanel();

    buttonPane.setLayout(new BoxLayout(buttonPane, BoxLayout.X_AXIS));

    JButton bReset = new JButton("Reset");
    bReset.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  This.reset();
	}
      });

    JButton bSet = new JButton("Set");
    bSet.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  This.update();
	}
      });

    buttonPane.add(bReset);
    buttonPane.add(Box.createRigidArea(new Dimension(15,0)));
    buttonPane.add(bSet);    

    add(Box.createRigidArea(new Dimension(0,5)));
    add(buttonPane);


    reset();
  }

  public void reset() {
    for (int i = 0; i < Values.length; i++) {
      Values[i].resetValue();
    }
    for (int i = 0; i < Checks.length; i++) {
      Checks[i].resetValue();
    }
  }
  public void update() {
    for (int i = 0; i < Values.length; i++) {
      if (Values[i].changed()) {
	Values[i].updateValue();
      }
    }
    for (int i = 0; i < Checks.length; i++) {
      if (Checks[i].changed()) {
	Checks[i].updateValue();
      }
    }
  }
}


interface MetronomeValueHolder {
  public abstract void resetValue();
  public abstract void updateValue();
  public abstract String getName();
  public abstract int getValue();
  public abstract boolean changed();
  public abstract void setEnabled(boolean e);
}

interface MetronomeBooleanHolder {
  public abstract void resetValue();
  public abstract void updateValue();
  public abstract String getName();
  public abstract boolean getValue();
  public abstract boolean changed();
  public abstract void setEnabled(boolean e);
}

interface MetronomeSpinnerSet {
  public abstract void reset(JSpinner spinner);
  public abstract void update(JSpinner spinner);
}
interface MetronomeCheckSet {
  public abstract void reset(JCheckBox cb);
  public abstract void update(JCheckBox cb);
}

class MetronomePropSpinner extends JPanel implements MetronomeValueHolder {
  String Name;
  MetronomeSpinnerSet Set;
  JSpinner Spinner;
  boolean Changed;

  public MetronomePropSpinner(String name, MetronomeSpinnerSet set,
			      int min, int max) {
    Name = name;
    Set = set;
    Spinner = new JSpinner(new SpinnerNumberModel(min, min, max, 1));
    Spinner.addChangeListener(new ChangeListener() {
	public void stateChanged(ChangeEvent e) {
	  Changed = true;
	}
      });

    setLayout(new GridLayout(0,2));
  
    add(new JLabel(Name));

    JPanel spinnerPane = new JPanel();
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    spinnerPane.setLayout(gridbag);
    c.fill = GridBagConstraints.HORIZONTAL;
    c.weightx = 0.5;
    c.gridx = 0;
    c.gridy = 0;
    gridbag.setConstraints(Spinner, c);
    spinnerPane.add(Spinner);
    add(spinnerPane);
  }

  public void resetValue() {
    Set.reset(Spinner);
    Changed = false;
  }
  public void updateValue() {
    Set.update(Spinner);
    Changed = false;
  }

  public String getName() { return Name; }
  public int getValue() { return ((Integer)Spinner.getValue()).intValue(); }
  public boolean changed() { return Changed; }
  public void setEnabled(boolean e) {
    resetValue();
    Spinner.setEnabled(e);
  }
}


class MetronomePropCheck extends JPanel implements MetronomeBooleanHolder {
  String Name;
  MetronomeCheckSet Set;
  JCheckBox Check;
  boolean Changed;

  public MetronomePropCheck(String name, MetronomeCheckSet set) {
    Name = name;
    Set = set;
    Check = new JCheckBox(Name);
    Check.addChangeListener(new ChangeListener() {
	public void stateChanged(ChangeEvent e) {
	  Changed = true;
	}
      });

    setLayout(new GridLayout(0,1));
  
    JPanel checkPane = new JPanel();
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    checkPane.setLayout(gridbag);
    c.fill = GridBagConstraints.HORIZONTAL;
    c.weightx = 0.5;
    c.gridx = 0;
    c.gridy = 0;
    gridbag.setConstraints(Check, c);
    checkPane.add(Check);
    add(checkPane);
  }

  public void resetValue() {
    Set.reset(Check);
    Changed = false;
  }

  public void updateValue() {
    Set.update(Check);
    Changed = false;
  }

  public String getName() { return Name; }
  public boolean getValue() { return Check.isSelected(); }
  public boolean changed() { return Changed; }
  public void setEnabled(boolean e) {
    resetValue();
    Check.setEnabled(e);
  }
}


/*****************************************************************************/

class NoiseAgentList extends JPanel {

  JList List;
  NamingContext NC;
  DefaultListModel Items;

  NoiseAgentManager PropertiesPane;

  private JComboBox InputAddress;
  private String[] DefaultAddresses = {"atp://localhost:4444"};

  private JButton BDispOk;

  public NoiseAgentList(NamingContext nc, NoiseAgentManager nam) {

    NC = nc;
    PropertiesPane = nam;

    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setLayout(gridbag);

    JLabel label = new JLabel("Choose an agent:");
    c.fill = GridBagConstraints.NONE;
    c.anchor = GridBagConstraints.WEST;
    c.gridx = 0;
    c.gridy = 0;
    gridbag.setConstraints(label, c);
    add(label);

    Items = new DefaultListModel();
    List = new JList(Items);
    List.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

    build();

    List.addListSelectionListener(new ListSelectionListener() {
	public void valueChanged(ListSelectionEvent e) {
	  if (!List.isSelectionEmpty())
	    openManager();
	}
      });

    JScrollPane scrollPane = new JScrollPane(List);

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;
    c.gridx = 0;
    c.gridy = 1;
    gridbag.setConstraints(scrollPane, c);
    add(scrollPane);

    JPanel refPane = new JPanel();
    refPane.setLayout(new BoxLayout(refPane, BoxLayout.Y_AXIS));
    
    JButton bRefresh = new JButton("Refresh list");
    bRefresh.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  refresh();
	}
      });
    c.fill = GridBagConstraints.NONE;
    c.anchor = GridBagConstraints.CENTER;
    c.weightx = 0.0;
    c.weighty = 0.0;
    c.gridx = 0;
    c.gridy = 2;
    gridbag.setConstraints(refPane, c);

    refPane.add(Box.createRigidArea(new Dimension(0,5)));
    refPane.add(bRefresh);

    add(refPane);

    JPanel dispPane = new JPanel();
    dispPane.setLayout(new BoxLayout(dispPane, BoxLayout.Y_AXIS));


    JPanel dispInputPane = new JPanel();
    dispInputPane.setLayout(new BoxLayout(dispInputPane, BoxLayout.X_AXIS));

    JLabel l = new JLabel("Destination URL ");

    InputAddress = new JComboBox(DefaultAddresses);
    InputAddress.setEditable(true);

    JPanel textPane = new JPanel();
    GridBagLayout gridbag2 = new GridBagLayout();
    textPane.setLayout(gridbag2);
    c.fill = GridBagConstraints.HORIZONTAL;
    c.ipady = 0;
    c.weightx = 1.0;
    c.weighty = 0.0;
    c.gridx = 0;
    c.gridy = 0;
    gridbag2.setConstraints(InputAddress, c);
    textPane.add(InputAddress);

    dispInputPane.add(l);
    dispInputPane.add(textPane);


    JPanel dispButtonPane = new JPanel();
    dispButtonPane.setLayout(new BoxLayout(dispButtonPane, BoxLayout.X_AXIS));

    BDispOk = new JButton("Dispatch");
    BDispOk.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  dispatch();
	}
      });

    dispButtonPane.add(BDispOk);

    dispPane.add(dispInputPane);
    dispPane.add(Box.createRigidArea(new Dimension(0,10)));
    dispPane.add(dispButtonPane);

    dispPane.setBorder(MyBorder.createBorder(5,0,5,0,
					      "Dispatch",
					      5,5,5,5));

    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridx = 0;
    c.gridy = 3;
    gridbag.setConstraints(dispPane, c);
    add(dispPane);

  }

  public void refresh() {
    Items.clear();
    build();
    List.repaint();
  }

  public void build() {
    System.out.println("building list...");
    try {
      BindingListHolder bl = new BindingListHolder();
      BindingIteratorHolder blIt= new BindingIteratorHolder();
      NC.list(1, bl, blIt);

      Binding bindings[] = bl.value;
      if (bindings.length == 0) return;

      for (int i=0; i < bindings.length; i++) {

	int lastIx = bindings[i].binding_name.length-1;

	if (bindings[i].binding_type != BindingType.ncontext) {
	  // FIXME
	  if (bindings[i].binding_name[lastIx].id.matches(".*Noise.*")) {
	    if (bindings[i].binding_type == BindingType.ncontext) continue;
	    org.omg.CORBA.Object obj = NC.resolve(bindings[i].binding_name);
	    MusicalAgent ma = MusicalAgentHelper.narrow(obj);
	    Items.addElement(new ListItem(ma));
	  }
	}
      }

      BindingIterator bIt = blIt.value;
      BindingHolder bh = new BindingHolder();

      while (bIt.next_one(bh)) {
	Binding b = bh.value;
	int lastIx = b.binding_name.length-1;
	if (b.binding_name[lastIx].id.matches(".*Noise.*")) {
	  if (b.binding_type == BindingType.ncontext) continue;
	  org.omg.CORBA.Object obj = NC.resolve(b.binding_name);
	  MusicalAgent ma = MusicalAgentHelper.narrow(obj);
	  Items.addElement(new ListItem(ma));
	}	
      }
    } catch (Exception e) {
      e.printStackTrace(System.err);
    }

  }

  public void openManager() {
    if (List.isSelectionEmpty()) return;

    try {
      ListItem li = ((ListItem)List.getSelectedValue());
      PropertiesPane.setMA(li.getMA());
    } catch (Exception e) {
      e.printStackTrace(System.err);
    }
  }

  public void dispatch() {
    if (List.isSelectionEmpty()) return;

    try {
      ListItem li = ((ListItem)List.getSelectedValue());
      MusicalAgent ma = li.getMA();
      ma.dispatch((String)InputAddress.getSelectedItem());
      System.out.println("Dispatch: " + InputAddress.getSelectedItem());
      refresh();
    } catch (Exception e) {
      e.printStackTrace(System.err);
    }
  }

  class ListItem {

    private MusicalAgent MA;
    private String Id;

    public ListItem(MusicalAgent ma) {
      Id = ma.name();
      MA = ma;
    }

    public MusicalAgent getMA() { return MA; }

    public String toString() {
      return Id;
    }
  }


}

/*****************************************************************************/

class NoiseAgentManager extends JPanel {

  private boolean Enabled;

  private MusicalAgent MA;

  static String [] Generators = {"White", "Pink", "Brownian", "Constant"};
  static String [] Scales = andante.apps.noiseweaver.Scales.getScales();

  private ValueHolder [] Values;

  private JButton BReset;
  private JButton BSet;

  private JButton BStart;
  private JButton BStop;

  private JLabel Title;

  public NoiseAgentManager (MusicalAgent ma) {
    this();
    setMA(ma);
  }

  public NoiseAgentManager () {
    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

    JPanel titlePane = new JPanel();
    Title = new JLabel("Choose an agent");
    titlePane.add(Title);
    add(titlePane);

    JPanel commsPane = new JPanel();

    commsPane.setLayout(new BoxLayout(commsPane, BoxLayout.X_AXIS));

    BStart = new JButton("Start");
    BStart.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  MA.play();
	  BStart.setEnabled(false);
	  BStop.setEnabled(true);
	}
      });
    BStop = new JButton("Stop");
    BStop.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  MA.stop();
	  BStop.setEnabled(false);
	  BStart.setEnabled(true);
	}
      });

    commsPane.add(Box.createHorizontalGlue());
    commsPane.add(BStart);
    commsPane.add(Box.createHorizontalGlue());
    commsPane.add(Box.createRigidArea(new Dimension(15,0)));
    commsPane.add(BStop);
    commsPane.add(Box.createHorizontalGlue());

    commsPane.setBorder(MyBorder.createBorder(0,5,5,5,
					      "Commands",
					      5,5,5,5));

    add(commsPane);

    JPanel PropsPane = new JPanel();

    SetPropertyComboPanel ppit = 
      new SetPropertyComboPanel(this, "PitchGenerator", Generators);
    SetPropertyComboPanel pvel = 
      new SetPropertyComboPanel(this, "IntensityGenerator", Generators);
    SetPropertyComboPanel pdur = 
      new SetPropertyComboPanel(this, "DurationGenerator", Generators);
    SetPropertyComboPanel psca = 
      new SetPropertyComboPanel(this, "Scale", Scales);

    SetPropertyNumberSpinnerPanel pScaleStart = 
      new SetPropertyNumberSpinnerPanel(this, "ScaleStart", 1, 128);
    SetPropertyNumberSpinnerPanel pScaleLength = 
      new SetPropertyNumberSpinnerPanel(this, "ScaleLength", 1, 128);

    SetPropertyNumberSpinnerPanel pChannel = 
      new SetPropertyNumberSpinnerPanel(this, "Channel", 1, 32);
    SetPropertyNumberSpinnerPanel pInstrument = 
      new SetPropertyNumberSpinnerPanel(this, "Instrument", 1, 128);

    SetPropertyMinMaxSpinnerPanel pDurMax = 
      new SetPropertyMinMaxSpinnerPanel(this, "DurationMax", 1, 10);
    SetPropertyMinMaxSpinnerPanel pDurMin = 
      new SetPropertyMinMaxSpinnerPanel(this, "DurationMin", 1, 10);
    pDurMax.setMin(pDurMin);
    pDurMin.setMax(pDurMax);

    SetPropertyMinMaxSpinnerPanel pVelMax = 
      new SetPropertyMinMaxSpinnerPanel(this, "IntensityMax", 0, 127);
    SetPropertyMinMaxSpinnerPanel pVelMin = 
      new SetPropertyMinMaxSpinnerPanel(this, "IntensityMin", 0, 127);
    pVelMax.setMin(pVelMin);
    pVelMin.setMax(pVelMax);

    PropsPane.setLayout(new BoxLayout(PropsPane, BoxLayout.Y_AXIS));
    Values = new ValueHolder[12];

    Values[0] = ppit;
    Values[1] = psca;
    Values[2] = pScaleStart;
    Values[3] = pScaleLength;
    Values[4] = pvel;
    Values[5] = pVelMin;
    Values[6] = pVelMax;
    Values[7] = pdur;
    Values[8] = pDurMin;
    Values[9] = pDurMax;
    Values[10] = pChannel;
    Values[11] = pInstrument;

    for (int i = 0; i < Values.length; i++)
      PropsPane.add((JPanel)Values[i]);

    PropsPane.setBorder(MyBorder.createBorder(5,5,5,5,
					      "Properties",
					      5,5,5,5));

    JPanel PropsButtonPane = new JPanel();

    PropsButtonPane.setLayout(new BoxLayout(PropsButtonPane, BoxLayout.X_AXIS));
    
    JButton bList = new JButton("List");
    bList.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  Property [] props = MA.listProperties();
	  for (int i = 0 ; i < props.length; i++) {
	    System.out.println(props[i].name + " " + props[i].value);
	  }
	}
      });

    BReset = new JButton("Reset");
    BReset.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  reset();
	}
      });

    BSet = new JButton("Set");
    BSet.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  for (int i = 0; i < Values.length; i++) {
	    if (Values[i].changed()) {
	      MA.setProperty(Values[i].getName(), Values[i].getValue());
	      Values[i].resetValue();
	    }
	  }
	}
      });

    PropsButtonPane.add(BReset);
    PropsButtonPane.add(Box.createRigidArea(new Dimension(15,0)));
    PropsButtonPane.add(BSet);    

    PropsPane.add(Box.createRigidArea(new Dimension(0,10)));
    PropsPane.add(PropsButtonPane);

    add(PropsPane);

    setEnabled(false);
  }


  MusicalAgent getMA() {
    return MA;
  }

  void reset() {
    for (int i = 0; i < Values.length; i++) {
      Values[i].resetValue();
    }
  }

  void setMA(MusicalAgent ma) {
    MA = ma;
    if (!isEnabled())
      setEnabled(true);
    if (MA.playing()) {
      BStart.setEnabled(false);
      BStop.setEnabled(true);
    } else {
      BStop.setEnabled(false);
      BStart.setEnabled(true);
    }
    Title.setText(MA.name());
    reset();
  }

  boolean hasMA() {
    return (MA != null);
  }

  public boolean isEnabled() { return Enabled; }

  public void setEnabled(boolean enabled) {
    Enabled = enabled;
    BReset.setEnabled(enabled);
    BSet.setEnabled(enabled);
    BStart.setEnabled(enabled);
    BStop.setEnabled(enabled);

    for (int i = 0; i < Values.length; i++) {
      Values[i].setEnabled(enabled);
    }
  }

}

class EKill extends WindowAdapter {
  public void windowClosing(WindowEvent e){
    System.exit(0);
  }
}


interface ValueHolder {
  public abstract void resetValue();
  public abstract String getName();
  public abstract String getValue();
  public abstract boolean changed();
  public abstract void setEnabled(boolean enabled);
}


class SetPropertyComboPanel extends JPanel implements ValueHolder {
  JComboBox Combo;
  String Name;
  NoiseAgentManager NAM;
  boolean Changed;

  public SetPropertyComboPanel(NoiseAgentManager nam, String name,
				 String [] values) {
    super();
    Name = name;
    NAM = nam;

    setLayout(new GridLayout(0,2));

    JLabel l = new JLabel(Name);
    add(l);

    Combo = new JComboBox(values);
    JPanel comboPane = new JPanel();
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    comboPane.setLayout(gridbag);
    c.fill = GridBagConstraints.HORIZONTAL;
    c.weightx = 0.5;
    c.gridx = 0;
    c.gridy = 0;
    gridbag.setConstraints(Combo, c);
    comboPane.add(Combo);
    add(comboPane);

    resetValue();

    Combo.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  System.out.println(Name + " changed");
	  Changed = true;
	}
      });
  }

  public void resetValue() {
    if (NAM.hasMA())
      Combo.setSelectedItem(NAM.getMA().getProperty(Name));
    Changed = false;
  }

  public String getName() { return Name; }

  public String getValue() {
    return (String)Combo.getSelectedItem();
  }

  public boolean changed() {
    return Changed;
  }

  public void setEnabled(boolean enabled) {
    Combo.setEnabled(enabled);
  }


}

class SetPropertyNumberSpinnerPanel extends JPanel implements ValueHolder {
  JSpinner Spinner;
  SpinnerModel SModel;
  String Name;
  boolean Changed;
  NoiseAgentManager NAM;

  public SetPropertyNumberSpinnerPanel(NoiseAgentManager nam, String name,
				 int min, int max) {
    super();
    Name = name;
    NAM = nam;
    SModel = new SpinnerNumberModel(min, min, max, 1);

    setLayout(new GridLayout(0,2));

  
    JLabel l = new JLabel(Name);
    add(l);

    Spinner = new JSpinner(SModel);

    JPanel spinnerPane = new JPanel();
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    spinnerPane.setLayout(gridbag);
    c.fill = GridBagConstraints.HORIZONTAL;
    c.weightx = 0.5;
    c.gridx = 0;
    c.gridy = 0;
    gridbag.setConstraints(Spinner, c);
    spinnerPane.add(Spinner);
    add(spinnerPane);

    resetValue();
    
    Spinner.addChangeListener(new ChangeListener() {
	public void stateChanged(ChangeEvent e) {
	  System.out.println(Name + " changed");
	  Changed = true;
	}
      });
  }

  public void resetValue() {
    if (NAM.hasMA())
      Spinner.setValue(new Integer(NAM.getMA().getProperty(Name)));
    Changed = false;
  }

  public String getName() { return Name; }

  public String getValue() {
    return String.valueOf((Integer)Spinner.getValue());
  }

  public int getIntValue() {
    return ((Integer)Spinner.getValue()).intValue();
  }

  public boolean changed() {
    return Changed;
  }

  public void setEnabled(boolean enabled) {
    Spinner.setEnabled(enabled);
  }
}

class SetPropertyMinMaxSpinnerPanel extends SetPropertyNumberSpinnerPanel {

  SetPropertyMinMaxSpinnerPanel Other;
  public SetPropertyMinMaxSpinnerPanel(NoiseAgentManager nam, String name,
				       int min, int max) {
    super(nam, name, min, max);
  }

  public void setMax(SetPropertyMinMaxSpinnerPanel other) {
    Other = other;
    Spinner.addChangeListener(new ChangeListener() {
	public void stateChanged(ChangeEvent e) {
	  if (Other.getIntValue() < ((Integer)Spinner.getValue()).intValue()) {
	    Spinner.setValue(new Integer(Other.getIntValue()));
	    Changed = false;
	  }
	  else Changed = true;
	}
      });
  }
  public void setMin(SetPropertyMinMaxSpinnerPanel other) {
    Other = other;
    Spinner.addChangeListener(new ChangeListener() {
	public void stateChanged(ChangeEvent e) {
	  if (Other.getIntValue() > ((Integer)Spinner.getValue()).intValue()) {
	    Spinner.setValue(new Integer(Other.getIntValue()));
	    Changed = false;
	  }
	  else Changed = true;
	}
      });
  }
}


/*****************************************************************************/

class NCListPanel extends JPanel {

  NCList List;

  public NCListPanel(NamingContext nc, String label,
		     boolean listCtx, boolean listObj) {
    super();

    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    setBorder(BorderFactory.createEmptyBorder(10,10,10,10));

    JButton bRefresh = new JButton("Refresh");
    JButton bManage = new JButton("Manage");
    bManage.setEnabled(false);
    List = new NCList(nc, label, bManage, listCtx, listObj);
    
    JPanel buttonPanel = new JPanel();
    buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
    buttonPanel.add(Box.createHorizontalGlue());
    buttonPanel.add(bRefresh);
    buttonPanel.add(Box.createHorizontalGlue());
    buttonPanel.add(bManage);
    buttonPanel.add(Box.createHorizontalGlue());

    List.setAlignmentX(Component.CENTER_ALIGNMENT);

    add(List);
    add(Box.createRigidArea(new Dimension(0,10)));
    add(buttonPanel);

    bRefresh.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  List.refresh();
	}
      });

    bManage.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  List.openManager();
	}
      });

/*    JButton bGet = new JButton("Get");

    JPanel buttonPanel = new JPanel();
//    buttonPanel.setBorder(BorderFactory.createEtchedBorder());
    buttonPanel.setBorder(BorderFactory.createEmptyBorder(10,5,10,10));
    buttonPanel.add(bGet);
    add(buttonPanel);

    bGet.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent e) {
	  try {
	    DefaultMutableTreeNode node = (DefaultMutableTreeNode)
	      Tree.getLastSelectedPathComponent();
	    NodeInfo ni = ((NodeInfo)node.getUserObject());
	    Binding b = ni.getBinding();
	    NamingContext nc = ni.getNamingContext();
	    System.out.println("aaa "  + ni);
	    org.omg.CORBA.Object obj = nc.resolve(b.binding_name);
	    if (b.binding_type == BindingType.ncontext) return;
	    MusicalAgent ma = MusicalAgentHelper.narrow(obj);
	    NoiseAgentManager nam  = new NoiseAgentManager(NAMTPane, ma);
	    NAMTPane.addTab("Agent " + ma.name(), nam);
	    Parent.pack();
	  } catch (Exception ex) { ex.printStackTrace(); }
	}
      });
*/
  }

}

class NCList extends JPanel {

  JList List;
  NamingContext NC;
  DefaultListModel Items;

  JButton BManage;

  boolean ListContexts;
  boolean ListObjects;

  public NCList(NamingContext nc, String label, JButton b, 
		boolean lcont, boolean lobj) {
    NC = nc;
    BManage = b;
    ListContexts = lcont;
    ListObjects = lobj;
    
    Items = new DefaultListModel();    
    List = new JList(Items);
    List.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    build();

    List.addListSelectionListener(new ListSelectionListener() {
	public void valueChanged(ListSelectionEvent e) {
	  if (List.isSelectionEmpty())
	    BManage.setEnabled(false);
	  else
	    BManage.setEnabled(true);
	}
      });

    List.addMouseListener(new MouseAdapter() {
	public void mouseClicked(MouseEvent e) {
	  if (e.getClickCount() == 2) {
	    //int index = List.locationToIndex(e.getPoint());
	    openManager();
          }
	}
      });

    JScrollPane scrollPane = new JScrollPane(List);
    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

    scrollPane.setAlignmentX(Component.LEFT_ALIGNMENT);

    add(new JLabel(label));
    add(Box.createRigidArea(new Dimension(0,5)));
    add(scrollPane);
  }

  public void refresh() {
    Items.clear();
    build();
  }

  public void build() {
    try {
      BindingListHolder bl = new BindingListHolder();
      BindingIteratorHolder blIt= new BindingIteratorHolder();
      NC.list(1, bl, blIt);

      Binding bindings[] = bl.value;
      if (bindings.length == 0) return;

///////////////
//      Items.addElement("villa1");
//      Items.addElement("lobos1");

      for (int i=0; i < bindings.length; i++) {

	int lastIx = bindings[i].binding_name.length-1;

	// check to see if this is a naming context
	if (bindings[i].binding_type == BindingType.ncontext) {
	  System.out.println("Context: " + bindings[i].binding_name[lastIx].id);
	  if (ListContexts) 
	    Items.addElement(new ListItem(bindings[i]));
	} else {
	  if (ListObjects)
	    Items.addElement(new ListItem(bindings[i]));
	  System.out.println(" Object: " + bindings[i].binding_name[lastIx].id);
	}
      }

      BindingIterator bIt = blIt.value;
      BindingHolder bh = new BindingHolder();

      while (bIt.next_one(bh)) {
	Binding b = bh.value;
	int lastIx = b.binding_name.length-1;

	// check to see if this is a naming context
	if (b.binding_type == BindingType.ncontext) {
	  if (ListContexts) 
	    Items.addElement(new ListItem(b));
	  System.out.println("Context: " + b.binding_name[lastIx].id);
	} else {
	  if (ListObjects) {
	    Items.addElement(new ListItem(b));
	  }
	  System.out.println(" Object: " + b.binding_name[lastIx].id);
	}
      }
    } catch (Exception e) {
      e.printStackTrace(System.err);
    }

  }

  public void openManager() {
    if (List.isSelectionEmpty()) return;


    try {
      ListItem li = ((ListItem)List.getSelectedValue());
      Binding b = li.getBinding();
      
      JFrame jf = new JFrame("NoiseWeaver - Stage villa1");
      
      org.omg.CORBA.Object obj = NC.resolve(b.binding_name);
      if (b.binding_type != BindingType.ncontext) return;
      NamingContext nc = NamingContextHelper.narrow(obj);

      System.out.println(nc);
    
      StageManager sm = new StageManager(nc);
    
      jf.getContentPane().add(sm);
      jf.pack();
      jf.show();    
    } catch (Exception e) {
      e.printStackTrace(System.err);
    }
  }


  class ListItem {

    private Binding B;

    public ListItem(Binding b) {
      B = b;
    }

    public Binding getBinding() { return B; }

    public String toString() {
      int lastIx = B.binding_name.length-1;
      return B.binding_name[lastIx].id;
    }
  }

}
