package andante.device;

import org.omg.PortableServer.*;
import andante.orb.device.*;
import andante.orb.*;

import javax.sound.midi.*;
import java.util.*;
import java.io.*;

public class AudioDeviceX extends AudioDevicePOA {

  String Id;

  Timer T;
  FileOutputStream Out;

  private byte[] B2 = new byte[2];
  private byte[] B3 = new byte[3];

  public AudioDeviceX() {
    Id = "Experimental Audio Device";
    T = new Timer();
    try {
      Out = new FileOutputStream("/dev/midi1");
    } catch (Exception e) { e.printStackTrace(); }
  }

  public String id () { return Id; }

  public void noteOn(int channel, int pitch, int vel) {
    try {
      B3[0] = (byte)(0x90 + channel);
      B3[1] = (byte)pitch;
      B3[2] = (byte)vel;
      Out.write(B3);
      Out.flush();
    } catch (Exception e) { e.printStackTrace(); }
  }
  public void noteOff(int channel, int pitch) {
    try {
      B3[0] = (byte)(0x80 + channel);
      B3[1] = (byte)pitch;
      B3[2] = (byte)0;
      Out.write(B3);
      Out.flush();
    } catch (Exception e) { e.printStackTrace(); }
  }

  public void sendMessage (int channel, andante.orb.Message m) {
    if (m.type.value() == MessageType.NOTE_ON.value()) {
      noteOn(channel, m.data[0], m.data[1]);
    }
    else if (m.type.value() == MessageType.NOTE_OFF.value()) {
      noteOff(channel, m.data[0]);
    }
    else if (m.type.value() == MessageType.NOTE_PLAY.value()) {
      noteOn(channel, m.data[0], m.data[1]);
      T.schedule(new TTNoteOff_(channel, m.data[0]), 
		 m.data[2]);
    }

  }

  class TTNoteOff_ extends TimerTask {    
    int C;
    int A;    
    public TTNoteOff_(int c, int pitch) {
      C = c;
      A = pitch;
    }    
    public void run() {
      noteOff(C, A);
    }
  }

  public void processSequence (andante.orb.Event[] seq) {
  }

  public void playMidiFile (byte[] arq) {
    System.out.println("DA: tocaArquivoMIDI " + arq.length);
  }

  /***************************************************************************/

  public void changeInstrument(int channel, short instr) {
    try {
      B2[0] = (byte)(0xC0 + channel);
      B2[1] = (byte)instr;
      printByteArray(B2);
      Out.write(B2);
      Out.flush();
    } catch (Exception e) { e.printStackTrace(); }
  }


  public static void printByteArray(byte [] b) {
    System.out.print("[ ");
    for (int i = 0; i < b.length; i++) {
      System.out.print((255+b[i])%255 + " ");
    }
    System.out.println("]");
  }

}



